﻿Public Class Cls_Routinen
   Public CursorPosition As Integer = 1


   Private Const EM_LINEFROMCHAR = &HC9   'verwendet in Get_CurrentLine_Index
   Private Const EM_LINEINDEX = &HBB      'verwendet in Get_CurrentLine_Index
   Private Const EM_LINELENGTH = &HC1     'verwendet in Get_CurrentLine_Index

   ''' <summary>
   ''' ermittelt die aktuelle Zeile in einer Multiline-Textbox
   ''' Rückgabe:  aktuelle Zeile 
   ''' </summary>
   Friend Function Get_CurrentLine_Index(TBoxHandle As IntPtr) As Integer
      Dim Ergo As Integer = 0

      Try
         Ergo = CInt(API_SendMessage(TBoxHandle, EM_LINEFROMCHAR, CType(-1, IntPtr), CType(0, IntPtr)) + 1)
      Catch ex As Exception
         Call ErrMeldung(ex:=ex)
      End Try
      Get_CurrentLine_Index = Ergo
   End Function 'Get_CurrentLine_Index



   ''' <summary>
   ''' Fehlermeldung anzeigen
   ''' </summary>
   Friend Sub ErrMeldung(ex As Exception)
      Dim TmpZeile As String = ex.StackTrace
      Dim TmpZeile1 As String = String.Empty
      Dim TmpZeile2 As String = String.Empty
      Dim TmpZeile3 As String = String.Empty, TmpLaenge3 As Integer = 0
      Dim TmpZeile4 As String = String.Empty
      Dim ErgoMeldung As String = String.Empty


      Try
         With TmpZeile
            If .IndexOf(value:="Zeile") > -1 Then
               TmpZeile1 = .Substring(.LastIndexOf("Zeile"))
            End If
         End With
         With TmpZeile1
            TmpZeile2 = .Substring(startIndex:=0, length:=5)
            TmpLaenge3 = .Length - 1
            TmpZeile3 = .Substring(startIndex:=6, length:=TmpLaenge3 - 6)
         End With
         TmpZeile4 = TmpZeile.Substring(startIndex:=0, length:=TmpZeile.LastIndexOf(value:="Zeile"))

         ErgoMeldung = "Datei:   " & TmpZeile4 & vbCrLf & "Modul:   " & ex.TargetSite.Name & vbCrLf &
                         TmpZeile2 & ":      " & TmpZeile3 & vbCrLf & vbCrLf & ex.Message
         MessageBox.Show(text:=ErgoMeldung, caption:="Fehler in " & ex.Source, _
                         buttons:=MessageBoxButtons.OK, icon:=MessageBoxIcon.Error)

         'Call ConsoleBox(ErgoMeldung)

      Catch exex As Exception
         MessageBox.Show(text:=exex.Message)
      End Try
   End Sub 'ErrMeldung



End Class
